import static com.kms.katalon.core.checkpoint.CheckpointFactory.findCheckpoint
import static com.kms.katalon.core.testcase.TestCaseFactory.findTestCase
import static com.kms.katalon.core.testdata.TestDataFactory.findTestData
import static com.kms.katalon.core.testobject.ObjectRepository.findTestObject
import com.kms.katalon.core.checkpoint.Checkpoint as Checkpoint
import com.kms.katalon.core.cucumber.keyword.CucumberBuiltinKeywords as CucumberKW
import com.kms.katalon.core.mobile.keyword.MobileBuiltInKeywords as Mobile
import com.kms.katalon.core.model.FailureHandling as FailureHandling
import com.kms.katalon.core.testcase.TestCase as TestCase
import com.kms.katalon.core.testdata.TestData as TestData
import com.kms.katalon.core.testobject.TestObject as TestObject
import com.kms.katalon.core.webservice.keyword.WSBuiltInKeywords as WS
import com.kms.katalon.core.webui.keyword.WebUiBuiltInKeywords as WebUI
import internal.GlobalVariable as GlobalVariable

// Define attribute values for fieldcrew account
def password = 'cropmetrics'
def email = 'cropmetricsvo.fieldcrew@gmail.com'
def fullname = 'test validation'
def phone = '123'
def dealer = 'x'
def addressLine1 = 'address line 1 test validation'
def addressLine2 = 'address line 2 test validation'
def town = 'townValidation'
def state = 'stateValidation'
def zip = 'xx'
def country = 'xx'
def roles = 'FieldCrew'

// Get token
def tokenUserName = 'admin'
def tokenPassword = 'cropmetricsvo'

responseToken = WS.sendRequest(findTestObject('VoPro/Token', [('usernameToken') : tokenUserName, ('passwordToken') : tokenPassword]))

// Get responseToken body response attributes
def slurper = new groovy.json.JsonSlurper()
def tokenResult = slurper.parseText(responseToken.getResponseBodyContent())

// Get result parameters of token
def accessToken = tokenResult.access_token

println('.. Current access token generated for admin user : ' + accessToken)

// Post new account 
responseAdminRegister = WS.sendRequest(findTestObject('VoPro/Account/api_admin_v1_users', [('access_token') : accessToken, ('password') : password, ('email') : email
	, ('fullname') : fullname, ('phone') : phone, ('dealer') : dealer, ('addressLine1') : addressLine1, ('addressLine2') : addressLine2, ('town') : town
	, ('state') : state, ('zip') : zip, ('country') : country, ('roles') : roles]))


// Define attribute values the new account trying to create this by fieldcrew account
def passwordByFieldCrew = 'cropmetrics'
def emailByFieldCrew = 'cropmetricsvo.clientByFieldCrew@gmail.com'
def fullnameByFieldCrew = 'test validation'
def phoneByFieldCrew = '123'
def dealerByFieldCrew = 'x'
def addressLine1ByFieldCrew = 'address line 1 test validation'
def addressLine2ByFieldCrew = 'address line 2 test validation'
def townByFieldCrew = 'townValidation'
def stateByFieldCrew = 'stateValidation'
def zipByFieldCrew = 'xx'
def countryByFieldCrew = 'xx'
def rolesByFieldCrew = 'Client'

// Get token
responseTokenByFieldCrew = WS.sendRequest(findTestObject('VoPro/Token', [('usernameToken') : email, ('passwordToken') : password]))

// Get responseToken body response attributes
def slurperByFieldCrew = new groovy.json.JsonSlurper()
def tokenResultByFieldCrew = slurperByFieldCrew.parseText(responseTokenByFieldCrew.getResponseBodyContent())

// Get result parameters of token client account
def accessTokenByFieldCrew = tokenResultByFieldCrew.access_token

println('.. Current access token generated by the new client account : ' + accessTokenByFieldCrew)

// Post new account
responseAdminRegisterByFieldCrew = WS.sendRequest(findTestObject('VoPro/Account/api_admin_v1_users', [('access_token') : accessTokenByFieldCrew, ('password') : passwordByFieldCrew, ('email') : emailByFieldCrew
	, ('fullname') : fullnameByFieldCrew, ('phone') : phoneByFieldCrew, ('dealer') : dealerByFieldCrew, ('addressLine1') : addressLine1ByFieldCrew, ('addressLine2') : addressLine2ByFieldCrew, ('town') : townByFieldCrew
	, ('state') : stateByFieldCrew, ('zip') : zipByFieldCrew, ('country') : countryByFieldCrew, ('roles') : rolesByFieldCrew]))

WS.verifyResponseStatusCode(responseAdminRegisterByFieldCrew, 401)

// Get response message for AdminRegister endpoint
def slurper1 = new groovy.json.JsonSlurper()
def AdminRegisterResult = slurper1.parseText(responseAdminRegisterByFieldCrew.getResponseBodyContent())
def messageResponse = AdminRegisterResult.message
def messageExpected = "Authorization has been denied for this request."

//Print message response
println('Error message response: ' + messageResponse)
println('Error message expected: ' + messageExpected)

WS.verifyElementPropertyValue(responseAdminRegisterByFieldCrew, 'message', messageExpected)
